//
// per_thread_logger.h
//
// Author:  <>, (C) 2007
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

#ifndef NTK_GUI_per_thread_logger_H
# define NTK_GUI_per_thread_logger_H

# include <ntk/core.h>
# include <vcl_map.h>

class ThreadLogger
{
  public:
    virtual ~ThreadLogger() {}
    virtual void logMessage(const String& message) = 0;
};

class PerThreadLogger : public Logger
{
  public:
    static PerThreadLogger* getInstance();

    void registerLogger(const Thread* thread, ThreadLogger* logger)
    { m_loggers[thread] = logger; }

    void removeLogger(const Thread* thread)
    { m_loggers.erase(thread); }

  protected:
    virtual void logMessage (const String &message);

  private:
    vcl_map<const Thread*,ThreadLogger*> m_loggers;
};

#endif // ndef NTK_GUI_per_thread_logger_H
