/*
** moments.h
** Login : <nicolas.burrus@ensta.fr>
** Started on  Thu Jun 23 23:26:21 2005 Nicolas Burrus
** $Id$
**
** Copyright (C) 2005, 2006, 2007 Nicolas Burrus
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#ifndef   	NTK_STATS_MOMENTS_H_
# define   	NTK_STATS_MOMENTS_H_

# include <ntk/core.h>

# include <vcl_memory.h>
# include <vcl_string.h>
# include <vcl_sstream.h>
# include <vcl_fstream.h>
# include <vcl_vector.h>

# include <vnl/vnl_erf.h>

namespace ntk
{

  using juce::Point; // FIXME: why is this required on mac os ?

  template <class T>
  void values_moments(const T& begin, const T& end, unsigned np, double* mean, double* dev);

  template <class T>
  void distrib_moments(const T& distrib, double& mean, double& dev);

  template <class T>
  void distrib_moments(const T& distrib, double& mean, double& dev, double& mu4);

  vcl_vector<double> distrib_to_bimodal_linear(const vcl_vector<double>& histogram);

  vcl_vector<double>
  fill_linear_values_from_control_points(const vcl_vector<Point>& points);

  void keep_local_maxima(vcl_vector<Point>* maxima, const vcl_vector<double>& histogram);
  vcl_vector<Point> make_unimodal_distribution(const vcl_vector<juce::Point>& points);

} // end of ntk

#include "moments.hxx"

#endif	    /* !NTK_STATS_MOMENTS_H_ */
