/*
** common.h
** Login : <nicolas.burrus@ensta.fr>
** Started on  Sun Oct 15 18:25:24 2006 Nicolas Burrus
** $Id$
** 
** Copyright (C) 2006, 2007 Nicolas Burrus
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#ifndef   	NTK_UTILS_COMMON_H_
# define   	NTK_UTILS_COMMON_H_

# include <ntk/core.h>

#define ntk_ptr_typedefs(Class) \
  typedef boost::shared_ptr<Class> Class##Ptr; \
  typedef boost::shared_ptr<const Class> Class##ConstPtr;

#define stl_bounds(s) s.begin(), s.end()

#define foreach_idx(Idxname, Vector) \
 for (size_t Idxname = 0; Idxname < (size_t)Vector.size(); ++Idxname)
    
#define foreach_uidx(Idxname, Vector) \
 for (uint32 Idxname = 0; Idxname < (uint32)Vector.size(); ++Idxname)
    
#define foreach_it(Itname, Instance, Type) \
 for (Type::iterator Itname = Instance.begin(); Itname != Instance.end(); ++Itname)

#define foreach_const_it(Itname, Instance, Type) \
 for (Type::const_iterator Itname = Instance.begin(); Itname != Instance.end(); ++Itname)

#define cat2(a, b) a,b
#define cat3(a, b, c) a,b,c
#define cat4(a,b,c,d) a,b,c,d

#endif 	    /* !NTK_UTILS_COMMON_H_ */
