//
// exception.h
//
// Author: Nicolas Burrus <nicolas.burrus@ensta.fr>, (C) 2007
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

#ifndef NTK_exception_H
# define NTK_exception_H

#include <ntk/core.h>
#include <ntk/utils/debug.h>
#include <vcl_exception.h>

#define ntk_throw_exception(msg) \
{ \
  String s; s << PRETTY_FUNCTION << ": " << msg; \
  throw ntk::exception(s); \
}

namespace ntk
{

  class exception : public vcl_exception
  {
    public:
      exception(juce::String& what) throw() : m_what(what)
      {}

      virtual ~exception() throw() {}

      virtual const char* what() const throw()
      { return m_what.toUTF8(); }

    private:
      String m_what;
  };

} // end of ntk

#endif // ndef NTK_exception_H
