//
// test-stl.cc
// 
// Author: Nicolas Burrus <nicolas.burrus@ensta.fr>, (C) 2007
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

#include <ntk/core.h>
#include <ntk/utils/stl.h>
#include <vcl_map.h>
#include <vcl_iostream.h>
#include <vcl_string.h>

using namespace ntk;

int main()
{
  vcl_map<vcl_string,vcl_string> m;
  m["hello"] = "bonjour";
  m["bye"] = "au revoir";
  
  {
    key_iterator< vcl_map<vcl_string,vcl_string>::const_iterator > it (m.begin());
    for (; it != m.end(); ++it)
      vcl_cout << it->c_str() << vcl_endl;
  }
  
  {
    value_iterator< vcl_map<vcl_string,vcl_string>::const_iterator > it (m.begin());
    for (; it != m.end(); ++it)
      vcl_cout << (*it).c_str() << vcl_endl;
  }
  
  return 0;
}

