//
// ac_segmentor.cc
// 
// Author: Nicolas Burrus <nicolas.burrus@ensta.fr>, (C) 2007
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

#include "ac_segmentor.h"
#include "ac_selector.h"
#include "ac_explorer.h"
#include "ac_learn_process.h"
#include <ntk/ntk_with_macros.h>

String AcSegmentor :: 
name() const
{
  return String("AcSegmentorV1") + m_explorer->name() + m_selector->name();
}

void AcSegmentor ::
initializeImpl()
{
  m_selector->initialize(*this);
  m_explorer->initialize(*m_selector);
}

void AcSegmentor :: 
segmentImpl()
{
  ntk_log() << (String)T("Regions before running acsegmentor: ") << nbRegions();
  PerformanceCounter pc ("AcSegmentor::segmentImpl", 1); pc.start();
  m_explorer->run();
  pc.stop();
  ntk_log() << (String)T("Regions after running acsegmentor: ") << nbRegions();
}

void AcSegmentor::
startLearningMode(AcLearner& learner)
{
  m_learner = &learner;
  m_selector->startLearningMode();
}

void AcSegmentor::
stopLearningMode()
{
  m_selector->stopLearningMode();
}
