//
// ac_segmentor.h
// 
// Author: Nicolas Burrus <nicolas.burrus@ensta.fr>, (C) 2007
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

#ifndef ACSEGMENTOR_ac_segmentor_H
# define ACSEGMENTOR_ac_segmentor_H

# include <ntk/core.h>

#include "segmentor.h"

class AcExplorer; ntk_ptr_typedefs(AcExplorer);
class AcSelector; ntk_ptr_typedefs(AcSelector);

class AcLearner;

class AcSegmentor : public Segmentor
{
  public:
    AcSegmentor(AcExplorerPtr explorer, AcSelectorPtr selector)
      : m_explorer(explorer), m_selector(selector), m_learner(0)
    {}
  
  public:
    virtual String name() const;
    
  public:
    AcExplorerPtr explorer() const { return m_explorer; }
    AcSelectorPtr selector() const { return m_selector; }

  public:
    void startLearningMode(AcLearner& leaner);
    void stopLearningMode();
    AcLearner& learner() { return *m_learner; }

  protected:
    virtual void initializeImpl();
    virtual void segmentImpl();
  
  private:
    AcExplorerPtr m_explorer;
    AcSelectorPtr m_selector;
    AcLearner* m_learner;
};

#endif // ndef ACSEGMENTOR_ac_segmentor_H
