//
// ac_threshold_database.h
// 
// Author: Nicolas Burrus <nicolas.burrus@ensta.fr>, (C) 2007
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

#ifndef ACSEGMENTOR_ac_threshold_database_H
# define ACSEGMENTOR_ac_threshold_database_H

# include <ntk/core.h>

# include <vcl_string.h>
# include <vcl_map.h>
# include <vcl_vector.h>

class ThresholdsExtractor; ntk_ptr_typedefs(ThresholdsExtractor);

class AcThresholdDatabase
{
  private:
    typedef vcl_map<String, ThresholdsExtractorPtr> threshold_map_type;
  
  public:
    AcThresholdDatabase();
    
  public:
    void loadFromXmlElement(const XmlElement& e);
    void loadFromFile(const char* filename);
    void saveToFile(const char* filename) const;
    XmlElement createXmlElement() const;
  
  public:
    vcl_vector<double> getThresholds(const PropertySet& properties);
    
  private:
    threshold_map_type m_thresholds;
};

ntk_ptr_typedefs(AcThresholdDatabase);

#endif // ndef ACSEGMENTOR_ac_threshold_database_H
