/*
  ==============================================================================

  This is an automatically generated file created by the Jucer!

  Creation date:  11 Sep 2007 5:01:15 pm

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Jucer version: 1.11

  ------------------------------------------------------------------------------

  The Jucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-6 by Raw Material Software ltd.

  ==============================================================================
*/

//[Headers] You can add your own extra header files here...
#include "../segmentor_factory.h"
#include "../ac_segmentor.h"
#include "ac_properties.h"
#include "segmentation_window.h"
//[/Headers]

#include <ntk/ntk_with_macros.h>
#include "segmentation_panel.h"


//[MiscUserDefs] You can add your own user definitions and misc code here...
using namespace ntk;
//[/MiscUserDefs]

//==============================================================================
SegmentationPanel::SegmentationPanel (PropertySetSubject& properties)
    : m_properties(properties),
      m_initializer_choice(0),
      m_panel (0),
      m_segment_button (0)
{
  //[Constructor_pre] You can add your own custom stuff here..
  //[/Constructor_pre]

  addAndMakeVisible (m_panel = new PropertyPanel());
  m_panel->setName (T("Panel"));

  addAndMakeVisible (m_segment_button = new TextButton (T("segment")));
  m_segment_button->setButtonText (T("Segment!"));
  m_segment_button->addButtonListener (this);


  //[UserPreSize]
  //[/UserPreSize]

  setSize (600, 400);

  //[Constructor] You can add your own custom stuff here..
  properties.addListener(*this);
  
  Array<PropertyComponent*> components;

  components.clear();
  components.add(new FileChoice(m_properties, "Input image",
                                "image_to_segment", false, false, T("*.pgm")));
  components.add(new FileChoice(m_properties, "Threshold database",
                                "threshold_database", false, true, T("*.xml")));
  m_panel->addSection("Files", components);

  components.clear();
  components.add(new SegmentorChoice(m_properties));
  components.add((m_initializer_choice = new InitializerChoice(m_properties)));
  components.add(new AcPropertyBoolean(m_properties,
                                       "Preserve all links", "keep_all_meaningful_links"));
  m_panel->addSection("Main algorithm", components);

  components.clear();
  components.add(new AcPropertyBoolean(m_properties, "Use mean", "use_mean"));
  components.add(new AcPropertyBoolean(m_properties, "Use deviation", "use_deviation"));
  components.add(new AcPropertyBoolean(m_properties, "Use frontier", "use_frontier"));
  m_panel->addSection("Selector", components);

  components.clear();
  components.add(new AcPropertyText(m_properties, "Sigma", "egbis-sigma"));
  components.add(new AcPropertyText(m_properties, "K", "egbis-k"));
  components.add(new AcPropertyText(m_properties, "min_size", "egbis-min-size"));
  m_panel->addSection("Egbis", components);

  components.clear();
  components.add(new AcPropertyText(m_properties, "Sigma", "watershed-sigma"));
  m_panel->addSection("Watershed", components);
  //[/Constructor]
}

SegmentationPanel::~SegmentationPanel()
{
  //[Destructor_pre]. You can add your own custom destruction code here..
  //[/Destructor_pre]

  deleteAndZero (m_panel);
  deleteAndZero (m_segment_button);

  //[Destructor]. You can add your own custom destruction code here..
    deleteAllChildren();
  //[/Destructor]
}

//==============================================================================
void SegmentationPanel::paint (Graphics& g)
{
    //[UserPrePaint] Add your own custom painting code here..
    //[/UserPrePaint]

    //[UserPaint] Add your own custom painting code here..
    //[/UserPaint]
}

void SegmentationPanel::resized()
{
    m_panel->setBounds (5, 5, getWidth() - 10, getHeight() - 39);
    m_segment_button->setBounds (proportionOfWidth (0.5000f) - ((104) / 2), getHeight() - 29, 104, 24);
    //[UserResized] Add your own custom resize handling here..
    //[/UserResized]
}

void SegmentationPanel::buttonClicked (Button* buttonThatWasClicked)
{
    //[UserbuttonClicked_Pre]
    //[/UserbuttonClicked_Pre]

    if (buttonThatWasClicked == m_segment_button)
    {
        //[UserButtonCode_m_segment_button] -- add your button handler code here..
      ntk_log() << "Segmenting ...";
      ntk_dbg(1) << (PropertySet&)m_properties;
      SegmentationWindow* window = new SegmentationWindow(m_properties);
      window->setVisible(true);
      window->startSegmentation();
        //[/UserButtonCode_m_segment_button]
    }

    //[UserbuttonClicked_Post]
    //[/UserbuttonClicked_Post]
}



//[MiscUserCode] You can add your own definitions of your custom methods or any other code here...
void SegmentationPanel :: onePropertyChanged(PropertySet&)
{
  if (m_properties.getValue("segmentor") == T("acsegmentor"))
  {
    if (m_initializer_choice) // may be called before its creation.
      m_initializer_choice->setEnabled(true);
  }
  else
  {
    if (m_initializer_choice) // may be called before its creation.
      m_initializer_choice->setEnabled(false);
  }
}
//[/MiscUserCode]


//==============================================================================
#if 0
/*  -- Jucer information section --

  This is where the Jucer puts all of its metadata, so don't change anything in here!

BEGIN_JUCER_METADATA

<JUCER_COMPONENT documentType="Component" className="SegmentationPanel" componentName=""
                 parentClasses="public Component, public PropertySetListener"
                 constructorParams="PropertySetSubject&amp; properties" variableInitialisers="m_properties(properties),&#10;m_initializer_choice(0)&#10;"
                 snapPixels="8" snapActive="1" snapShown="1" overlayOpacity="0.330000013"
                 fixedSize="0" initialWidth="600" initialHeight="400">
  <BACKGROUND backgroundColour="ffffff"/>
  <GENERICCOMPONENT name="Panel" id="6895a6f1fffbba29" memberName="m_panel" virtualName=""
                    explicitFocusOrder="0" pos="5 5 10M 39M" class="PropertyPanel"
                    params=""/>
  <TEXTBUTTON name="segment" id="d83bb36db8048fed" memberName="m_segment_button"
              virtualName="" explicitFocusOrder="0" pos="50%c 29R 104 24" buttonText="Segment!"
              connectedEdges="0" needsCallback="1" radioGroupId="0"/>
</JUCER_COMPONENT>

END_JUCER_METADATA
*/
#endif
